(function(){
var consolelog = consolelog || function(l) {
  if(typeof(console.log) == "function") {
    console.log(l);
  }
}
  if (typeof window.XWiki == "undefined") {    // global XWiki namespace
    window.XWiki = {};
  }
  var XWiki = window.XWiki;
  if(typeof XWiki != 'undefined' && typeof XWiki.Dropdown == 'undefined') {
    XWiki.Dropdown = Class.create();
    XWiki.Dropdown.prototype = {
      initialize: function(activator, dropdown, options)  {
        this.activator = activator;
        this.dropdown = dropdown;
        this.initialized = false;
        this.options = { delay: 250,
                         duration: .25, }
        Object.extend(this.options, options || {});
        Event.observe(this.activator, 'mouseover', this.mouseoverActivator.bindAsEventListener(this));
        Event.observe(this.activator, 'mouseout', this.mouseoutActivator.bindAsEventListener(this));
        Event.observe(this.dropdown, 'mouseover', this.mouseoverDropdown.bindAsEventListener(this));
        Event.observe(this.dropdown, 'mouseout', this.mouseoutDropdown.bindAsEventListener(this));
      },
      
      mouseoverActivator: function(e) {
        if(!this.initialized) {
          this.timeout = window.setTimeout(this.appear.bind(this), this.options.delay);
        }
      },

      mouseoutActivator: function(e) {
        if(this.appearfx) {
          this.appearfx.cancel();
          delete this.appearfx;
        }        
        this.fadefx = new Effect.Fade(this.dropdown, {duration: this.options.duration});
        this._clearTimeout(this.timeout);
        this.initialized = false;
      },

      mouseoverDropdown: function(e) {
        if(this.fadefx) {
          this.fadefx.cancel();
          delete this.fadefx;
        }
        this.appearfx = new Effect.Appear(this.dropdown, 'appear', {duration: this.options.duration});
      },

      mouseoutDropdown: function(e) {
        if(this.appearfx) {
          this.appearfx.cancel();
          delete this.appearfx;
        }
        this.fadefx = new Effect.Fade(this.dropdown, {duration: this.options.duration});
      },

      appear: function() {
        this.initialized = true;
        this.appearFX = Effect.Appear(this.dropdown, {duration: this.options.duration});
        var container = Element.ancestors(this.activator)[0];
        var ccoords = Element.viewportOffset(container);
        var acoords = Element.viewportOffset(this.activator);
        var ddwidth = Element.getWidth(this.dropdown);
        if(ddwidth < acoords.left - ccoords.left) {
          this.dropdown.style.width = (acoords.left - ccoords.left) + 'px';
        }
      },
      _clearTimeout: function(t) {
        //consolelog('_cleartimeout');
        clearTimeout(t);
        clearInterval(t);
        return null;
      }
    };
  };
 })();
